/*
 * 
 *  dynamic linker command file
 *  generated: Sat Jan  7 13:12:32 2006

 *  kernel   : brickOS
 *  app start: 0xa8d4
 * 
 *  BrickOS for LEGO(R) Mindstorms(TM)
 *  Originally: legOS - the independent LEGO Mindstorms OS
 *              (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x28d4
  ram   : o = 0xa8d4, l = 0x5628
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x001a ;
    _mm_try_join = 0x0120 ;
    _mm_defrag = 0x015e ;
    _mm_update_first_free = 0x019c ;
    _mm_init = 0x01c2 ;
    _malloc = 0x0226 ;
    _free = 0x02cc ;
    _calloc = 0x02f6 ;
    _mm_reaper = 0x033e ;
    _mm_free_mem = 0x036c ;
    _clock_handler = 0x03aa ;
    _subsystem_handler = 0x03ce ;
    _task_switch_handler = 0x0430 ;
    _systime_tm_return = 0x044a ;
    _systime_init = 0x045e ;
    _systime_shutdown = 0x04d6 ;
    _systime_set_switcher = 0x04e8 ;
    _systime_set_timeslice = 0x04ee ;
    _get_system_up_time = 0x050c ;
    _tm_switcher = 0x0522 ;
    _tm_scheduler = 0x053e ;
    _yield = 0x06da ;
    _tm_man_task = 0x06f8 ;
    _tm_battery_task = 0x073c ;
    _tm_init = 0x0784 ;
    _tm_start = 0x07f2 ;
    _execi = 0x0804 ;
    _exit = 0x09a4 ;
    _wait_event = 0x09c6 ;
    _msleep = 0x0a70 ;
    _sleep = 0x0aac ;
    _shutdown_task = 0x0ad0 ;
    _shutdown_tasks = 0x0adc ;
    _kill = 0x0b2c ;
    _killall = 0x0b68 ;
    _sem_event_wait = 0x0bea ;
    _sem_wait = 0x0c04 ;
    _sem_timedwait = 0x0c78 ;
    _sem_trywait = 0x0cc0 ;
    _delay = 0x0cd8 ;
    _cputc_native = 0x0cf8 ;
    _cputc_native_0 = 0x0d26 ;
    _cputc_native_1 = 0x0d5a ;
    _cputc_native_2 = 0x0d90 ;
    _cputc_native_3 = 0x0dca ;
    _cputc_native_4 = 0x0e06 ;
    _cputc_native_5 = 0x0e42 ;
    _cputw = 0x0e4e ;
    _cputs = 0x0e92 ;
    _cls = 0x0eda ;
    _lcd_number = 0x0ee2 ;
    _lcd_refresh_next_byte = 0x0f82 ;
    _lcd_refresh_next_byte_core = 0x0f96 ;
    _lcd_refresh = 0x0fe6 ;
    _lcd_power_on = 0x1016 ;
    _lcd_power_off = 0x1028 ;
    _lcd_init = 0x1044 ;
    _rx_handler = 0x108e ;
    _rx_core = 0x10a2 ;
    _rxerror_handler = 0x110a ;
    _rxerror_core = 0x111e ;
    _txend_handler = 0x1160 ;
    _txend_core = 0x1174 ;
    _tx_handler = 0x1182 ;
    _tx_core = 0x1196 ;
    _lnp_logical_shutdown = 0x11be ;
    _lnp_logical_init = 0x11de ;
    _lnp_logical_write = 0x12a4 ;
    _lnp_integrity_write = 0x136a ;
    _lnp_addressing_write = 0x13cc ;
    _lnp_receive_packet = 0x1460 ;
    _lnp_integrity_byte = 0x14de ;
    _lnp_integrity_reset = 0x15aa ;
    _lnp_integrity_reset_core = 0x15be ;
    _lnp_timeout_reset = 0x15ea ;
    _lnp_timeout_reset_core = 0x15fe ;
    _lnp_init = 0x1608 ;
    _lnp_integrity_active = 0x1622 ;
    _lnp_timeout_set = 0x162e ;
    _program_valid = 0x1638 ;
    _program_stop = 0x19f2 ;
    _key_handler = 0x1a62 ;
    _program_init = 0x1d0e ;
    _program_shutdown = 0x1d62 ;
    _vis_handler = 0x1d6c ;
    _vis_core = 0x1d80 ;
    _get_battery_mv = 0x1dda ;
    _shutoff_restart = 0x1e04 ;
    _shutoff_init = 0x1e14 ;
    _autoshutoff_check = 0x1e20 ;
    _autoshutoff_check_core = 0x1e34 ;
    _dkey_handler = 0x1e64 ;
    _dkey_pressed = 0x1ea2 ;
    _dkey_released = 0x1ec4 ;
    _getchar = 0x1ee4 ;
    _dm_init = 0x1f0e ;
    _dm_shutdown = 0x1f12 ;
    _motor_a_dir = 0x1f34 ;
    _motor_b_dir = 0x1f72 ;
    _motor_c_dir = 0x1fb4 ;
    _ds_rotation_set = 0x1ff4 ;
    _ds_rotation_handler = 0x2048 ;
    _ds_init = 0x2140 ;
    _ds_shutdown = 0x2176 ;
    _dsound_handler = 0x218e ;
    _dsound_core = 0x21a2 ;
    _dsound_init = 0x2296 ;
    _dsound_shutdown = 0x22ae ;
    _dsound_stop = 0x22b2 ;
    _dsound_finished = 0x22d2 ;
    _atomic_inc = 0x22ec ;
    _atomic_dec = 0x22fa ;
    _locked_check_and_increment = 0x2308 ;
    _wait_critical_section = 0x2342 ;
    _enter_critical_section = 0x2364 ;
    _setjmp = 0x2392 ;
    _longjmp = 0x23ae ;
    _memcpy = 0x23c2 ;
    _memset = 0x23d4 ;
    ___mulhi3 = 0x23e2 ;
    ___udivhi3 = 0x23f2 ;
    ___mulsi3 = 0x2404 ;
    ___divsi3 = 0x2420 ;
    _hex_display_codes = 0x246a ;
    _ascii_display_codes = 0x247a ;
    _min_length = 0x250c ;
    _dm_a_pattern = 0x253c ;
    _dm_b_pattern = 0x2540 ;
    _dm_c_pattern = 0x2544 ;
    _firmware_string = 0x2626 ;
    _etext = 0x2626 ;
    _lcd_refresh_period = 0x2628 ;
    _lnp_hostaddr = 0x262a ;
    _lnp_timeout = 0x262c ;
    _vis_refresh_counter = 0x262e ;
    _vis_refresh_period = 0x262f ;
    _battery_refresh_counter = 0x2630 ;
    _battery_refresh_period = 0x2632 ;
    _auto_shutoff_counter = 0x2634 ;
    _auto_shutoff_period = 0x2636 ;
    _auto_shutoff_secs = 0x2638 ;
    _auto_shutoff_elapsed = 0x263a ;
    _idle_powerdown = 0x263c ;
    _dsound_system_sounds = 0x263e ;
    _bss_start = 0x2640 ;
    __edata = 0x2640 ;
    _mm_first_free = 0x282a ;
    _tm_timeslice = 0x282c ;
    _tm_current_slice = 0x282d ;
    _tm_switcher_vector = 0x282e ;
    _sys_time = 0x2830 ;
    _ctid = 0x2840 ;
    _td_single = 0x2850 ;
    _nb_tasks = 0x2864 ;
    _priority_head = 0x2866 ;
    _nb_system_tasks = 0x2868 ;
    _lcd_byte_counter = 0x286a ;
    _lcd_refresh_counter = 0x286b ;
    _tx_state = 0x286c ;
    _lnp_integrity_handler = 0x2870 ;
    _lnp_timeout_counter = 0x2872 ;
    _lnp_addressing_handler = 0x2880 ;
    _lnp_integrity_state = 0x28a0 ;
    _packet_len = 0x28a2 ;
    _cprog = 0x28a4 ;
    _packet_src = 0x28a6 ;
    _dkey_timer = 0x28a8 ;
    _dkey = 0x28a9 ;
    _dkey_multi = 0x28aa ;
    _dm_a = 0x28ac ;
    _dm_b = 0x28b0 ;
    _dm_c = 0x28b4 ;
    _ds_rotation = 0x28b8 ;
    _ds_channel = 0x28b9 ;
    _ds_rotations = 0x28bc ;
    _ds_activation = 0x28c2 ;
    _dsound_next_note = 0x28c4 ;
    _dsound_internote_ms = 0x28c6 ;
    _dsound_16th_ms = 0x28c8 ;
    _dsound_next_time = 0x28cc ;
    _kernel_critsec_count = 0x28d0 ;
    _end = 0x28d2 ;
    _mm_start = 0x28d2 ;
    _dm_handler = 0x7002 ;
    ___etext_hi = 0x704a ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _WDT_CSR = 0xa8 ;
    _WDT_CNT = 0xa9 ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
